# Neuroglia Python Framework

A framework of libraries used to build modern Python V3 applications

## Disclaimer

This project was the opportunity for me (cdavernas) to learn Python while porting some of the concepts and services of the .NET version of the Neuroglia Framework

## Packaging

```sh
# Set the version tag in pyproject.toml
# Commit changes

poetry build

poetry publish --repository gitlab -u <token-username> -p <token-password>

```

---

_DRAFT_

## Developer Guide Structure

### Introduction

Briefly describe your framework, its purpose, and its target audience.
Highlight key features and benefits.

#### Installation:

Provide clear and step-by-step instructions on how to install your framework, including:
Prerequisites (e.g., Python version, dependencies)
Installation methods (e.g., pip install <framework_name>, source code compilation)
Virtual environment recommendations (for isolation and dependency management)

#### Getting Started:

Offer a simple "Hello, World!" or similar example to demonstrate basic usage and familiarize users with your framework's syntax and structure.
Include code snippets and explanations where necessary.

#### Core Concepts:

Dedicate this section to in-depth explanations of the fundamental building blocks and functionalities of your framework. This might include:
Key objects and classes within the framework
Data structures and design patterns employed
Architectural overview (e.g., MVC, MVVM) if applicable

#### Tutorials and Examples:

Provide a collection of well-structured, step-by-step tutorials that showcase how to accomplish common tasks using your framework.
Consider varying the difficulty levels (beginner, intermediate, advanced) to cater to a wide range of users.
Include code examples, explanations, and screenshots as needed.

#### API Reference:

Create a comprehensive reference for all available classes, functions, and modules within your framework.
Use a consistent format that includes the following information for each API element:
Name
Description
Arguments (with data types and descriptions)
Return values (with data types and descriptions)
Usage examples

#### Testing and Debugging:

Explain how to effectively test code written using your framework.
Recommend testing frameworks and tools.
Provide practical guidance on common debugging techniques and strategies.

#### Contributing:

Outline how developers can contribute to your framework's development.
Include information on:
Issue tracking system (e.g., GitHub issues)
Pull request guidelines
Coding style and conventions
Testing requirements

#### Community and Support:

Specify available resources for users to seek help and engage with the community. This could include:
Official channels (e.g., discussion forums, mailing lists)
Third-party resources (e.g., Stack Overflow tags, community blogs)

#### License:

Clearly state the license under which your framework is distributed.

#### Additional Tips:

Maintain a clear and concise writing style, using easy-to-understand language.
Ensure proper formatting and structure for readability.
Provide code snippets in a visually appealing format, using code blocks and syntax highlighting.
Consider adding screenshots or diagrams to illustrate complex concepts.
Regularly update the guide with new features, bug fixes, and best practices.
